package com.changhong.epc.parsing.mapper.tenant.asset;

import com.changhong.epc.bean.form.Asset;
import com.changhong.epc.bean.tenant.asset.FixedAsset;
import com.iemsoft.framework.cloud.mybatis.common.MybatisBaseMapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

public interface FixedAssetMapper extends MybatisBaseMapper<FixedAsset> {

    int updateAssetByCode(@Param("acc") FixedAsset acc
            , @Param("formId") String formId);

    Asset getMinDateAsset(
            @Param("orgCode") String orgCode
            , @Param("yesCode") String yesCode
            , @Param("formId") String formId
    );

    List<Asset> getAllAssetByFirstOrgCode(
            @Param("orgCode") String orgCode
            , @Param("date") String date
            , @Param("assetCode") String assetCode
            , @Param("yesCode") String yesCode
            , @Param("formId") String formId
    );

    FixedAsset getLastDepreciation(FixedAsset fixedAsset);
    
    int deleteFixedAsset(FixedAsset fixedAsset);

    int notAssetDepreciation(
            @Param("orgCode") String orgCode
            , @Param("date") String date
            , @Param("yesCode") String yesCode
            , @Param("formId") String formId);



    //表单列表导出用

    /**
     * 查询列表总条数
     * @param formId
     * @return
     */
    Integer selectFormCount(@Param("formId")String formId);

    /**
     * 分页查询列表数据,id为null时，查询主表数据，pageNum为null时查询字表数据
     */
    List<Map<String,Object>> selectFormInfo(@Param("formName") String formName
            ,@Param("id") String id,@Param("pageNum") Integer pageNum,@Param("pageSize") Integer pageSize);

    Integer getSumAlreadyTime(@Param("asset") Asset asset, @Param("date") String date);
}
