package com.changhong.epc.parsing.service.autosubmit.entity;

import lombok.Data;

import java.util.List;
import java.util.Map;

/**
 * 表单公式参数
 * @author WangYX
 *
 */
@Data
public class FormulaParam {

	/**
	 * 租户id
	 */
	private String tenantID;
	
	/**
	 * 表单id
	 */
	private String formID;
	
	/**
	 * 表单数据
	 */
	private Map<String, Object> data;
	
	/**
	 * 触发事件条件
	 */
	private List<TriggerCondition> triggers;
	
	/**
	 * 表单提交
	 */
	private Boolean formCommit;
	
	/**
	 * 触发事件条件实体
	 * @author WangYX
	 *
	 */
	@Data
	public static class TriggerCondition{
		
		/**
		 * 子表单数据下标
		 */
		private Integer index;
		
		/**
		 * 别名
		 */
		private String alias;
		
		/**
		 * 值
		 */
		private Object value;
		
	}
}
