package com.changhong.epc.parsing.service.autosubmit.entity;

import com.changhong.epc.parsing.service.autosubmit.prop.CpnMsg;
import com.changhong.epc.parsing.service.autosubmit.prop.MsgType;
import lombok.Data;

import java.util.List;
import java.util.Map;

/**
 * 公式返回值类型
 * @author WangYX
 *
 */
@Data
public class FormulaResult {
	
	/**
	 * 表单数据
	 */
	private Map<String, Object> data;
	
	/**
	 * 表单提示的消息
	 */
	private List<Map<MsgType, String>> formMsgs;
	
	/**
	 * 表单控件提示的消息
	 */
	private Map<String, Object> cpnMsgs;
	
	@Data
	public static class CpnMsgInfo{
		
		/**
		 * 消息类型
		 */
		private CpnMsg msgType;
		
		/**
		 * 错误消息
		 */
		private List<String> msgs;
		
		/**
		 * 行程数据下标
		 */
		private Integer index;
		
	}
	
}
