package com.changhong.epc.parsing.service.autosubmit.info;

import java.util.List;
import java.util.Map;

import com.changhong.epc.parsing.service.autosubmit.prop.MsgType;

/**
 * 表单主体
 * @author WangYX
 *
 */
public interface Form extends Map<String, Object>{

	/**
	 * 表单fieldId
	 */
	String FORM_KEY = "表单";
	
	/**
	 * 表单加载
	 */
	void loading();
	
	/**
	 * 表单提交
	 */
	void commit();
	
	/**
	 * 添加表单控件
	 * @param formCpn
	 */
	void addFormCpn(FormCpn formCpn);
	
	/**
	 * 添加表单公式
	 */
	void setAllFormulas(List<FormulaInfo> formulaInfos);
	
	/**
	 * 添加表单监听
	 */
	void setFormListener(FormListener formListener);

	/**
	 * 添加表单提示消息
	 * @param key
	 * @param value
	 * @param abstractBaseFormCpn
	 */
	void setMsg(MsgType key, String value, FormCpn formCpn);
	
	/**
	 * 获得表单提示信息
	 * @return
	 */
	List<Map<MsgType, String>> getMsgs();
	
	/**
	 * 获得表单公式
	 * @return
	 */
	List<FormulaInfo> getFormulas();
	
	/**
	 * 触发控件
	 * @param formCpn
	 */
	boolean triggerEvent(FormCpn formCpn);

	/**
	 * 添加业务数据
	 * @param data
	 */
	void setData(Map<String, Object> data);
	
	/**
	 * 获得业务数据
	 * @return
	 */
	Map<String, Object> getData();

	/**
	 * 获得控件错误信息
	 * @return
	 */
	Map<String, Object> getCpnMsgs();
}
