package com.changhong.epc.parsing.service.autosubmit.info;

import com.changhong.epc.parsing.service.autosubmit.prop.Attribute;
import com.changhong.epc.parsing.service.autosubmit.prop.MsgType;
import lombok.Data;

import java.util.List;

/**
 * 公式信息
 * @author WangYX
 *
 */
@Data
public class FormulaInfo {

	/**
	 * 显示信息
	 */
	private String code;
	
	/**
	 * 公式信息
	 */
	private String conditionCode;
	
	/**
	 * 触发事件
	 */
	private Event event;
	
	/**
	 * 返回结果集合
	 */
	private List<ResultInfo> results;
	
	/**
	 * 事件实体
	 * @author WangYX
	 *
	 */
	@Data
	public static class Event{
		
		/**
		 * 事件
		 */
		private String doEvent;
		
		/**
		 * 控件别名
		 */
		private String eventField;
	}
	
	/**
	 * 公式结果信息
	 * @author WangYX
	 *
	 */
	@Data
	public static class ResultInfo{
		
		/**
		 * 控件属性
		 */
		private Attribute attribute;
		
		/**
		 * 结果公式
		 */
		private String code;
		
		/**
		 * 控件别名
		 */
		private String eventField;
		
		/**
		 * 下标
		 */
		private Integer index;
		
		/**
		 * 消息信息
		 */
		private String message;
		
		/**
		 * 消息类型
		 */
		private MsgType messageType;
		
		/**
		 * 结构类型
		 */
		private Integer mode;
		
	}
}
