package com.changhong.epc.parsing.service.bill;

import java.util.List;

import com.changhong.epc.bean.parsing.BillInfo;
import com.changhong.epc.bean.tenant.bill.OCRBillEntity;
import com.changhong.epc.bean.tenant.system.extend.ErrSystemMsgExtend;
import com.changhong.epc.constter.parsing.bill.ConstCorresElField;

public interface BillMappingJourney extends ConstCorresElField {

	
	
	/**
	 * 返回行程信息
	 * @Title: mapping
	 * @param @param bill
	 * @param @param journeyCpn
	 * @param @return    设定文件
	 * @return List<Map<String,Object>>    返回类型
	 * @throws
	 */
	public void mappingJourney(BillInfo billInfo);
	
	/**
	 * 返回处理后的票据信息
	 * @Title: resultOCRBillEntity
	 * @param @return    设定文件
	 * @return OCRBillEntity    返回类型
	 * @throws
	 */
	public OCRBillEntity resultOCRBillEntity();
	
	
	public List<ErrSystemMsgExtend> getRecordErrCode();
	
	
}
