package com.changhong.epc.parsing.service.bill.impl;


import com.changhong.epc.bean.parsing.BillInfo;
import com.changhong.epc.bean.tenant.sunCloud.PushOrderBill;
import com.changhong.epc.constter.base.BaseConst;
import com.changhong.epc.parsing.mapper.tenant.BillInfoMapper;
import com.changhong.epc.parsing.service.bill.BillInfoService;
import com.changhong.epc.rely.api.service.CscApiService;
import com.iemsoft.framework.cloud.core.tools.JSONTool;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;

@Slf4j
@Service
public class BillInfoServiceImpl implements BillInfoService,BaseConst {

	@Resource
	private BillInfoMapper billInfoMapper;
	
	@Resource
	private CscApiService cscApiService;
	
	
	@Override
	@Transactional
	public int billInfoInsert(PushOrderBill pushOrderBill) {
		BillInfo billInfo = new BillInfo();
		billInfo.setOrderCode(pushOrderBill.getOrderCode());
		billInfo.setDataStart(2);
		billInfo.setInfo(pushOrderBill.getBillDatas());
		try{
			/**发起订单规则检查*/
			cscApiService.orderRuleCheck(billInfo.getOrderCode());
		}catch(Exception ex){
			log.error("----------------规则检查出错了---------------:{}", JSONTool.toJson(pushOrderBill));
		}
		/**添加票据信息*/
		int result = billInfoMapper.updateBill(billInfo);
		if(result == 0)
			result = billInfoMapper.addBill(billInfo);
		return result;
	}
	

}
