package com.changhong.epc.parsing.service.cscApi.impl;

import com.alibaba.fastjson.TypeReference;
import com.changhong.epc.parsing.service.cscApi.OrgApiService;
import com.changhong.epc.rely.api.bean.Company;
import com.changhong.epc.rely.api.bean.Tenant;
import com.changhong.epc.rely.api.bean.TenantsAndCompanys;
import com.changhong.epc.rely.api.service.CscApiService;
import com.changhong.epc.rely.api.tool.CscUtils;
import com.iemsoft.framework.cloud.core.tools.JSONTool;
import com.iemsoft.framework.cloud.core.tools.http.Http;
import org.springframework.stereotype.Service;
import org.springframework.ui.ModelMap;

import javax.annotation.Resource;
import java.util.Map;
import java.util.Objects;
import java.util.function.Consumer;

@Service("orgApiServiceImpl")
public class OrgApiServiceImpl implements OrgApiService{

	@Resource(name="cscApiServiceImpl")
	private CscApiService cscApiService;
	
//	@Override
//	public String getCompanyAll(String userCode) {
//		String s = null;
//		TenantsAndCompanys companys = cscApiService.findTenantAndOrg();
//		for (Tenant o : companys.getTenants()) {
//			if (userCode.equals(o.getOrgCode())) {
//				s =  Objects.toString(o.getId());
//			};
//		};
//		return s;
//	}


	@Override
	public void getCompanyAll(String tenantOrgCode, String companyOrgCode, Consumer<Tenant> tenantConsumer, Consumer<Company> companyConsumer) {
		TenantsAndCompanys companys = cscApiService.findTenantAndOrg();
		Tenant t = companys.getTenants()
				.stream()
				.filter(tenant -> Objects.equals(tenantOrgCode, tenant.getOrgCode()))
				.findFirst()
				.orElse(null);
		if(t == null){
			return;
		}
		tenantConsumer.accept(t);
		Company c = cscApiService.getCompanyOrgs(t.getId())
				.stream()
				.filter(company -> Objects.equals(companyOrgCode, company.getOrgCode()))
				.findFirst()
				.orElse(null);
		if(c == null){
			return;
		}
		companyConsumer.accept(c);
	}

	public static void main(String... args){
		Map<String, Object> o =
//		Http.post("http://csza.chfcloud.com/csc-ie-user/rest/json/api/tenant/findTenantAndOrg", Map.class)
//		Http.post("http://csza.chfcloud.com/csc-ie-user/rest/json/api/tenant/findTenantCompanys", Map.class)
		Http.post("http://csza.chfcloud.com/csc-ie-user/rest/json/api/tenant/findCompanysAndOrg", Map.class)
				.addUrlParam(CscUtils.getParam(new ModelMap("tenantId", 100000001)))
//				.addUrlParam(CscUtils.getParam(new ModelMap()))
				.execute(new TypeReference<Map<String, Object>>(){}.getType())
				.orElse(new ModelMap());
		System.out.println(JSONTool.toJson(o));
	}

}
