package com.changhong.epc.parsing.service.loop.tools.impl;

import java.util.Collections;
import java.util.Comparator;
import java.util.Date;
import java.util.List;
import java.util.Objects;

import org.apache.commons.lang3.StringUtils;

import com.changhong.epc.bean.tenant.bill.OCRBillHeaderEntity;
import com.changhong.epc.constter.parsing.bill.ConstCorresElField;

public class SortBill implements ConstCorresElField {

	private SortBill(){
		
	}
	/**
	 * 排序票据
	 * @Title: sortBill
	 
	 * @param @param bill    设定文件
	 * @return void    返回类型
	 * @throws
	 */
	public static void sortBill(List<OCRBillHeaderEntity> bills) {
		//Collections.sort(bills, getComparator());
		
		Collections.sort(bills, new Comparator<OCRBillHeaderEntity>() {

			@Override
			public int compare(OCRBillHeaderEntity o1, OCRBillHeaderEntity o2) {
				if(getDate(o1).compareTo(getDate(o2)) != 0){
					return getDate(o1).compareTo(getDate(o2));
				}else{
					
					try {
						if (getTime(o1).compareTo(getTime(o2)) != 0) {
							return getTime(o1).compareTo(getTime(o2));
						}
					} catch (Exception e) {
					}
					return Objects.equals(o1.getVal(TO),o2.getVal(FROM))  ? 
								-1 :  (Objects.equals(o1.getVal(FROM), o2.getVal(TO)) ? 1:0);
				}
			}
			
		});
		
	}

	protected static Comparator<OCRBillHeaderEntity> getComparator() {
		return (OCRBillHeaderEntity bill1, OCRBillHeaderEntity bill2)->
			getDate(bill1).compareTo(getDate(bill2));
			
		
	}
	
	protected static Date getDate(OCRBillHeaderEntity billInfo){
		/*
		 * 默认返回开始时间
		 */
		String data = billInfo.getVal(FROM_DATE);
		if(StringUtils.isNotBlank(data)){
			return YMDTools.getDate(data);
		}
		/*
		 * 为空则返回截止时间
		 */
		data = billInfo.getVal(TO_DATE);
		if(StringUtils.isNotBlank(data)){
			return YMDTools.getDate(data);
		}
		/*
		 * 否则当前时间
		 */
		return new Date();
	}
	
	public  static String getTime(OCRBillHeaderEntity billInfo){
		
		/*
		 * 默认返回开始时间
		 */
		String data = billInfo.getVal(FROM_TIME);
		if(StringUtils.isNotBlank(data)){
			return YMDTools.getTime(data);
		}
		/*
		 * 为空则返回截止时间
		 */
		data = billInfo.getVal(TO_TIME);
		if(StringUtils.isNotBlank(data)){
			return YMDTools.getTime(data);
		}
		return null;
	}

}
