package com.changhong.epc.parsing.service.util;

import java.util.List;
import java.util.Map;

import com.changhong.epc.bean.form.CpnVal;
import com.changhong.epc.bean.form.Fieldsets;
import com.changhong.epc.bean.form.FormBaseEntity;
import com.changhong.epc.bean.form.FormDataEntity;
import com.changhong.epc.bean.parsing.BillInfo;
import com.changhong.epc.bean.tenant.bill.OCRBillEntity;
import com.changhong.epc.bean.tenant.master.MasterEleValue;
import com.changhong.epc.bean.tenant.master.MasterValue;


/**
 * 对接自定义表单接口
 * @author wangZX
 *
 */
public interface IFromOperate {	
	
	public int updateFormStatusTe(BillInfo billInfo,Integer status,Integer tenantId);
	
	MasterValue billValToCode(MasterEleValue masterEleValue);
	
	FormBaseEntity selectFromAll(OCRBillEntity OCRBillEntity);
	
	int updateFormStatus(BillInfo billInfo,Integer status);
	/**
	 * 查询表单详情
	 * @param order
	 * @return
	 */
	public FormBaseEntity selectFromAll(BillInfo billInfo);
	
	/**
	 * 保存控件值
	 * @param data
	 * @return
	 */
	public Integer insertCpnVal(BillInfo billInfo, Map<CpnVal, List<List<CpnVal>>> data);
	
	
	/**
	 * 删除orderCode 对应的表单id
	 */
	public Boolean deleteFormData(BillInfo billInfo, CpnVal subForm);

	/**
	 * 添加多条子表单返回子表单数据
	 * @param billInfo
	 * @param journeySubForm
	 * @param allJourneyCpn
	 * @return
	 */
	public List<Integer> insertCpnVal(BillInfo billInfo,CpnVal journeySubForm, List<List<CpnVal>> allJourneyCpn);

	/**
	 * 更新表单
	 * @param data
	 */
	public void updateForm(Map<String,Object> data);
	
	/**
	 * 设置要插入的字表单
	 * @param journeySubForm
	 */
//	public void setJourneySubForm(CpnVal journeySubForm);
	
	/**
	 * 更改表单中的数据
	 * @param billInfo
	 * @param subForm
	 * @param allCpn
	 * @return
	 */
	public boolean updateCpnVal(BillInfo billInfo, Map<CpnVal, List<List<CpnVal>>> data );

	
	/**
	 * 查询表单详情
	 * @param selectFromAll
	 * @return
	 */
	public Map<CpnVal, List<Map>> selectfromDataAll(BillInfo billInfo, Fieldsets fieldsets);
	
	/**
	 * 查询费用类型id
	 * @param formId
	 * @return
	 */
	public Integer getBillType(String formId);

	/**
	 * 查询单条数据
	 * @param formData
	 * @return
	 */
	Map<String,Object> selectFromData(BillInfo formData, Fieldsets fieldsets, OCRBillEntity oCRBillEntity);

	/**
	 * 修改表单数据
	 * @param formDataEntity
	 */
	void updateFormData(FormDataEntity formDataEntity);
	
	int updateFormStatus(String formId,String tenangId,String dataRowNum,Integer status);

	/**
	 * 查询主表单数据
	 */
	Map<String,Object> selectSign(String formId,String tenangId,Integer dataRowNum);

	/**
	 * 查询子表单数据
	 */
	List<Map> selectSubList(String formId,String tenangId,Integer dataRowNum,String alias);

	/**
	 * 费用类型id 转code
	 */
	String getCostCode(Integer ctId);
}
